<?php
class ImaxChatFree extends Module {

    var $versionPS;
    var $idShop;
    var $idLang;
    var $idTab;
    private $_html = '';

    const prefijo = 'CHAT_IMAX';

    public function __construct() {
        $this->name = 'imaxchatfree';
        $this->tab = 'administration';
        $this->version = '1.0';
        $this->author = 'Informax';
        $this->need_instance = 0;
        $this->idManual = '';
        $this->forceCheck = 0;
        parent::__construct();
        $this->displayName = $this->l('Chat Online Free by Informax');
        $this->description = $this->l('Modulo Live Helper Chat');

        if (version_compare(_PS_VERSION_, '1.5.0.0 ', '>=')) {
            $this->versionPS = 15;
            $this->idLang = Configuration::getGlobalValue('PS_LANG_DEFAULT');
            $this->idShop = Configuration::getGlobalValue('PS_SHOP_DEFAULT');
        }

        $this->getTxtFiles();
		$this->registerHook('displayTop');
    }

    public function install() {
        include(dirname(__FILE__) . '/configuration.php');
        foreach ($configuracion AS $indice => $valor) {
            if (!Configuration::updateGlobalValue($indice, $valor)) {
                return false;
            }
        }


		
        if (!parent::install())
            return false;


        if (!$this->installTab()) {
            $this->_errors[] = $this->l('Error al instalar el tab');
            return false;
        }

        return true;
    }

    public function uninstall() {
		$this->unregisterHook('displayTop');
		
        if (!parent::uninstall()) {
            return false;
        }
        if (!$this->uninstallTab()) {
            $this->_errors[] = $this->l('Error al eliminar el tab');
            return false;
        }

        Configuration::updateGlobalValue(self::prefijo . 'JS_CODE', '');
        Configuration::updateGlobalValue(self::prefijo . 'JS_CODE_ST', 0);
        
        include(dirname(__FILE__) . '/configuration.php');
        foreach ($configuracion AS $indice => $valor) {
            if (Configuration::getGlobalValue($indice) !== FALSE) {
                if (!Configuration::deleteByName($indice)) {
                    return false;
                }
            }
        }

        return true;
    }

    public function getContent() {
        $this->addCSS('css.css');
        $this->addJS('functions.js');
        $this->addCSS('publi.css');
        $this->_html .= $this->createHelpHeader();
        if (!empty($_POST))
            $this->_html .= $this->_postProcess();

        $this->_displayForm();
        $this->_html .= $this->getModuleFooter();
        return $this->_html;
    }

    private function _postProcess() {
        $accion = Tools::getValue("action");
        $this->idTab = Tools::getValue("idTab");
        $activo = Tools::getValue('jsStatus');
        $html = "";		
        switch ($accion) {
            case 'addJS':
                if (Configuration::updateGlobalValue(self::prefijo . 'JS_CODE', base64_encode(serialize(trim(Tools::getValue('js'))))) 
					&& Configuration::updateGlobalValue(self::prefijo  . 'JS_CODE_ST', $activo))
                    $html .= $this->displayConfirmation($this->l('Script guardada correctamente.'));
                else
                    $html .= $this->displayError($this->l('Ha ocurrido un error al guardar el JS'));
                break;
            default:
                break;
        }

        return $html;
    }

    private function _displayForm() {

        if ($this->idTab == '' || empty($this->idTab)) {
            $this->idTab = 1;
        }
        $urlTienda = $this->getUrlAdmin();
        $token = Tools::getAdminTokenLite('AdminModules');
        $moduleLink = $urlTienda . 'index.php?controller=AdminModules&token=' . $token . '&configure=' . $this->name . '&tab_module=administration&module_name=' . $this->name;

        $this->_html .='<script>'
                . ' var nameModule = "' . $this->name . '"; '
                . ' var url_admin = "' . $urlTienda . '"; '
                . ' var url_modulo = "' . $moduleLink . '"; '
                . ' </script>';
        $this->_html .= '<ul id="menuTab">
                    <li id="menuTab1" class="menuTabButton' . (($this->idTab == 1) ? " selected" : "") . '">' . $this->l('Configuracion') . '</li>';
        $this->_html .= '</ul>';
        $this->_html .= '
		<div id="tabList">
                    <div id="menuTab1Sheet" class="tabItem' . (($this->idTab == 1) ? " selected" : "" ) . '">' . $this->_configuracion() . '</div>';

        $this->_html .= '</div>';
        $this->_html .= '<style>
				#menuTab { float: left; padding: 0; margin: 0; text-align: left; }
				#menuTab li { text-align: left; float: left; display: inline; padding: 5px; padding-right: 10px; background: #EFEFEF; font-weight: bold; cursor: pointer; border-left: 1px solid #EFEFEF; border-right: 1px solid #EFEFEF; border-top: 1px solid #EFEFEF; }
				#menuTab li.menuTabButton.selected { background: #FFF6D3; border-left: 1px solid #CCCCCC; border-right: 1px solid #CCCCCC; border-top: 1px solid #CCCCCC; }
				#tabList { clear: left; }
				.tabItem { display: none; }
				.tabItem.selected { display: block; background: #FFFFF0; border: 1px solid #CCCCCC; padding: 10px; padding-top: 20px; }
			</style>
			<script>
				$(".menuTabButton").click(function () {
				  $(".menuTabButton.selected").removeClass("selected");
				  $(this).addClass("selected");
				  $(".tabItem.selected").removeClass("selected");
				  $("#" + this.id + "Sheet").addClass("selected");                                 
				});
			</script>';
    }

    private function _configuracion() {
        $js = unserialize(base64_decode(Configuration::getGlobalValue(self::prefijo . 'JS_CODE')));
        $jsStatus = Configuration::getGlobalValue(self::prefijo . 'JS_CODE_ST');
		$checked = '';
        if ($jsStatus == 1) {
            $checked = ' checked="checked"';
        }
        $html = '<fieldset><legend>' . $this->l('Codigo Js autogenerado desde LIVE HELPER CHAT') . '</legend>
          <form action="' . Tools::safeOutput($_SERVER['REQUEST_URI']) . '" method="post">        
          <input type="hidden" name="action" value="addJS" />  ';

        $html .= '<input type="hidden" name="idTab" value="1" />';
        $html .= '<p><label>' . $this->l('Activar Log:') . '</label> ';
        $html .= '<input type="checkbox" name="jsStatus" value="1" ' . $checked . '/></p>';
        $html .= '<p>' . $this->displayWarning($this->l('Aqui desactivamos o activamos el sistema de Chat Para Prestashop')) . '';
        $html .= '<p><label>' . $this->l('Codigo JS:') . '</label> ';
        $html .= '<textarea name="js" />' . $js .' </textarea></p>';
        $html .= '<p>' . $this->displayWarning($this->l('Ojo con lo que guardamos aqui.')) . '';
        $html .= '<br /><input type="submit" name="guardarJS" value="' . $this->l('Guardar Js') . '" />
			</form></fieldset>';
        return $html;

        $html .= $acordeon->renderAcordeon($this->l('Preferencias'), $form->renderForm());
        return $html;
    }

    private function _mostrarLicencia() {
        return $html;
    }

    private function _checkVersion() {
        return false;
    }

    public function hookDisplayTop($params) {		
        if (Configuration::getGlobalValue(self::prefijo . 'JS_CODE_ST') == 1){			
            return unserialize(base64_decode(Configuration::getGlobalValue(self::prefijo . 'JS_CODE')));
		}
    }

    function addCSS($css) {
        $tab = Tools::getValue('tab', 0);
        if (!$tab || ($tab && $tab != 'AdminSelfUpgrade')) {
            $this->context->controller->addCss($this->_path . 'css/' . $css, 'all');
        }
//$this->_html .= '<link type="text/css" rel="stylesheet" href="../modules/' . $this->name . '/css/' . $css . '" />' . "\n";
        return;
    }

    function addJS($js) {
        $tab = Tools::getValue('tab', 0);
        if (!$tab || ($tab && $tab != 'AdminSelfUpgrade')) {
            $this->context->controller->addJs($this->_path . 'js/' . $js);
        }
//$this->_html .= '<link type="text/css" rel="stylesheet" href="../modules/' . $this->name . '/css/' . $css . '" />' . "\n";
        return;
    }

    function addJqueryUI($plugin) {
        $tab = Tools::getValue('tab', 0);
        if (!$tab || ($tab && $tab != 'AdminSelfUpgrade')) {
            if ($this->context->controller instanceof stdClass) {
                $this->context->controller = new AdminModulesController();
            }
            $this->context->controller->addJqueryUI($plugin);
        }
        return;
    }

    public function createHelpHeader() {
        $html = '<div class="module-preheader">';
        $html .= $this->getDatosPubli('header');
        $html .= '</div>';

        $html .= '<div class="module-header">';
        $html .= '<div class="module-title-container">';
        $html .= '<h2 class="module-title">' . $this->displayName . '<small> by Informax</small></h2>';
        $html .= '<h3 class="module-version">' . $this->l('Version: ') . $this->version . '</h3>';
        $html .= '</div>';

        $html .= '<div class="module-toolbar">';
        $html .= '<ul class="module-nav" >';

        $html .= '<li>';
        $html .= '<a target="_blank" href="http://www.informax.es">';
        $html .= '<img src="../modules/' . $this->name . '/img/informax.png">';
        $html .= '<div>' . $this->l('Informax') . '</div>';
        $html .= '</a>';
        $html .= '</li>';

        $html .= '<li>';
        $html .= '<a target="_blank" href="http://tickets.informax.es/open.php?topicId=10">';
        $html .= '<img src="../modules/' . $this->name . '/img/abrir-ticket.png">';
        $html .= '<div>' . $this->l('Asistencia') . '</div>';
        $html .= '</a>';
        $html .= '</li>';

        $html .= '<li>';
        $html .= '<a target="_blank" href="http://docs.informax.es/?p=' . $this->idManual . '">';
        $html .= '<img src="../modules/' . $this->name . '/img/ir-a-manuales.png">';
        $html .= '<div>' . $this->l('Manuales') . '</div>';
        $html .= '</a>';
        $html .= '</li>';

        $html .= '</ul>';
        $html .= '</div>';
        $html .= '</div>';
        return $html;
    }

    public function getModuleFooter() {
        $url = Configuration::getGlobalValue(self::prefijo . 'URL_FALDON');
        $html = '<div class="module-newsletter">';
        $html .='<form action="http://www.informax.es/subscribe/" method="post" target="_blank">
                    <input type="hidden" name="accion" value="newsletter">
                    <input type="hidden" name="idTab" value="1" />';
        $html .= '<p>' . $this->l('Si deseas enterarte de todos los cambios en nuestros modulos, nuevos Modulos, como funciona Prestashop, apuntate a nuestras news') . '</p>';
        $html .= ' <p>';
        $html .= ' <label>' . $this->l('email') . '</label>';
        $html .= '<input type="text" name="email" value="" />';
        $html .= '<input type="submit" name="subscribe" value="' . $this->l('Guardar') . '" />';
        $html .= '</p>';
        $html .= '</form><br />';
        $html .= '</div>';
        $html .= '<div class="module-footer">';
        $html .= '<div class="module-footer-left">';
        $html .= $this->getDatosPubli('footera');
        $html .= '</div>';
        $html .= '<div class="module-footer-right">';
        $html .= $this->getDatosPubli('footerb');
        $html .= '</div>';
        $html .= '</div>';
        return $html;
    }

    public function getDatosPubli($tipo) {
        $datosCompletos = Configuration::getGlobalValue(self::prefijo . 'TXT_FILE');

        $html = '';
        if ($datosCompletos) {
            $aperturaA = '';
            $cierreA = '';
            $datosCompletos = @unserialize($datosCompletos);
            if (!is_array($datosCompletos)) {
                return '';
            }
            shuffle($datosCompletos);
            foreach ($datosCompletos AS $datoElemento) {
                if ($datoElemento[1] == $tipo) {
                    if (trim($datoElemento[2]) != '') {
                        $aperturaA .= '<a href="' . $datoElemento[2] . '" target="_blank">';
                        $cierreA = '</a>';
                    }
                    if (trim($datoElemento[0]) != '') {
                        $html = $aperturaA . '<img src="' . Configuration::getGlobalValue(self::prefijo . 'URL_TXT') . '/img/' . $datoElemento[0] . '" />' . $cierreA;
                    }
                    return $html;
                }
            }
        }
        return $html;
    }

    public function getTxtFiles() {
        if (Configuration::getGlobalValue(self::prefijo . 'DESCARGA_ARCHIVO') < 10000) {
            Configuration::updateGlobalValue(self::prefijo . 'DESCARGA_ARCHIVO', Configuration::getGlobalValue(self::prefijo . 'DESCARGA_ARCHIVO') + 1);
            return false;
        }
        $url = Configuration::getGlobalValue(self::prefijo . 'URL_TXT') . '/' . Configuration::getGlobalValue(self::prefijo . 'TIPO') . '.txt';
        $basedir_active = ini_get('open_basedir');
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 360);
        if (!$basedir_active) {
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
        }
        $datos = curl_exec($ch);
        $infoCurl = curl_getinfo($ch);
        if (!isset($infoCurl['http_code']) || $infoCurl['http_code'] != 200) {

            return false;
        }
        Configuration::updateGlobalValue(self::prefijo . 'DESCARGA_ARCHIVO', 0);
        return Configuration::updateGlobalValue(self::prefijo . 'TXT_FILE', $this->readCsv($datos));
    }

    private function readCsv($string) {
        $string = trim($string);
        $temp = explode("\n", $string);
        $respuesta = array();
        foreach ($temp AS $elemento) {
            $elementoInterno = array();
            $elementoInterno = explode(";", $elemento);
            $respuesta[] = $elementoInterno;
        }
        return serialize($respuesta);
    }

    function l($msg, $modulo = '') {
        if ($modulo == '') {
            $modulo = 'traducciones' . strtolower($this->name);
        }
        return parent::l($msg, $modulo);
    }

    /**
     * Crea un nuevo tab.
     * @param string $clase
     * @param string $nombre
     * @param string $padre
     * @return boolean
     */
    private function crearTab($clase, $nombre, $padre = '') {
        if (!Tab::getIdFromClassName($clase)) {
            $tab = new Tab();
            $tab->active = 1;
            $tab->class_name = $clase;
            $tab->name = array();
            foreach (Language::getLanguages(true) as $lang) {
                $tab->name[$lang['id_lang']] = $nombre;
            }
            if ($padre == '') {
                $posicion = 0;
            } else {
                $posicion = Tab::getIdFromClassName($padre);
            }
            $tab->id_parent = intval($posicion);
            $tab->module = $this->name;
            try {
                if (!$tab->add()) {
                    return false;
                }
            } catch (Exception $exc) {
                return false;
            }
        }

        return true;
    }

    /**
     * Borra un tab.
     * @param string $clase
     * @return boolean
     */
    private function borrarTab($clase) {
        $id_tab = (int) Tab::getIdFromClassName($clase);
        if ($id_tab) {
            $tab = new Tab($id_tab);
            try {
                if (!$tab->delete()) {
                    return false;
                }
            } catch (Exception $exc) {
                return false;
            }
        }

        return true;
    }

    /**
     * Instala los tabs del módulo.
     * @return boolean
     */
    private function installTab() {
        include(dirname(__FILE__) . '/configuration.php');

        //Instalamos el root
        if (isset($moduleTabRoot) && $moduleTabRoot) {
            $this->crearTab($moduleTabRoot['clase'], $moduleTabRoot['name']);
        }

        //Instalamos el resto de tabs
        if (isset($moduleTabs) && $moduleTabs) {
            foreach ($moduleTabs AS $moduleTab) {
                $this->borrarTab($moduleTab['clase']);
                if (!$this->crearTab($moduleTab['clase'], $moduleTab['name'], $moduleTab['padre'])) {
                    return false;
                }
            }
        }

        return true;
    }

    /**
     * Desinstala los tabs del módulo.
     * @return boolean
     */
    private function uninstallTab() {
        include(dirname(__FILE__) . '/configuration.php');

        //Desinstalamos las tabs de este módulo
        if (isset($moduleTabs) && $moduleTabs) {
            foreach ($moduleTabs AS $moduleTab) {
                if (!$this->borrarTab($moduleTab['clase'])) {
                    return false;
                }
            }
        }

        //Desinstalamos el root si está vacío
        if (isset($moduleTabRoot) && $moduleTabRoot) {
            $id_tab = (int) Tab::getIdFromClassName($moduleTabRoot['clase']);
            if ($id_tab && Tab::getNbTabs($id_tab) == 0) {
                if (!$this->borrarTab($moduleTabRoot['clase'])) {
                    return false;
                }
            }
        }

        return true;
    }

    private function checkLicencia($force = 0) {
        $data = array();
        $f = Configuration::getGlobalValue(self::prefijo . 'F');
        $check = Configuration::getGlobalValue(self::prefijo . 'F_CHECK');
        $url = Configuration::getGlobalValue(self::prefijo . 'F_SERVER');
        $function = new Functionsimaxeancomparator();
        $data['server'] = $this->getDomain();
        $data['modulo'] = $this->name;
        $data['action'] = 'checkLicencia';
        $data['licencia'] = Configuration::getGlobalValue(self::prefijo . 'LICENCIA');
        if ($check >= 100 || $force == 1) {
            $ch = curl_init($url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
            $datos = curl_exec($ch);
            $datos = json_decode($datos);
            $info = curl_getinfo($ch);
            if ($datos->codError != 0) {
                Configuration::updateGlobalValue(self::prefijo . 'F', '');
                Configuration::updateGlobalValue(self::prefijo . 'F_CHECK', (int) $check + 1);
                return false;
            } else {
                Configuration::updateGlobalValue(self::prefijo . 'F', $datos->msgError);
                Configuration::updateGlobalValue(self::prefijo . 'F_CHECK', 0);
                return true;
            }
        } else {
            Configuration::updateGlobalValue(self::prefijo . 'F_CHECK', (int) $check + 1);
            return true;
        }
    }

    private static function getUrlAdmin() {
        $temp = explode('/', $_SERVER['PHP_SELF']);
        $dummy = array_pop(($temp));
        $urlAdmin = implode('/', $temp);
        if (Configuration::get('PS_SSL_ENABLED') == 1) {
            $url = 'https://';
        } else {
            $url = 'http://';
        }
        $url .= $_SERVER['SERVER_NAME'] . $urlAdmin . '/';
        return $url;
    }

    public function displayWarning($error) {
        if ($this->versionPS == 15) {
            $output = '
			<div class="module_error alert warn">
				' . $error . '
			</div>';
        } else {
            $output = '<div class="bootstrap">'
                    . '<p class="warning warn alert alert-warning">'
                    . $error .
                    '</p></div>';
        }
        return $output;
    }

    public function getDomain() {
        $idShopDefault = Configuration::getGlobalValue('PS_SHOP_DEFAULT');
        $tienda = new Shop($idShopDefault);
        if (Validate::isLoadedObject($tienda)) {
            if (isset($tienda->domain)) {
                return $tienda->domain;
            }
        } return false;
    }

}
